"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initDbInstances = void 0;
const sequelize_cockroachdb_1 = __importDefault(require("sequelize-cockroachdb"));
const fs_1 = __importDefault(require("fs"));
const initDbInstances = (service, databases) => {
    for (const db of databases) {
        switch (db.type) {
            case 'crdb':
                service.databases[db.database] = initCrdb(db);
                break;
            default:
                console.log('invalid database type');
        }
    }
};
exports.initDbInstances = initDbInstances;
const initCrdb = (db) => {
    const { port, host, database, user, password, certDir } = db;
    // @ts-ignore
    return new sequelize_cockroachdb_1.default(database, user, password || '', {
        dialect: 'postgres',
        port: port,
        host: host,
        logging: false,
        operatorsAliases: false,
        dialectOptions: {
            ssl: {
                ca: fs_1.default.readFileSync(certDir + `ca.crt`)
                    .toString(),
                key: fs_1.default.readFileSync(certDir + `client.${user}.key`)
                    .toString(),
                cert: fs_1.default.readFileSync(certDir + `client.${user}.crt`)
                    .toString()
            }
        }
    });
};
